import { UseGuards } from '@nestjs/common';
import { AuthGuard } from '../../controller/auth/auth.guard';
import { ApiBearerAuth } from '@nestjs/swagger';

/**
 * 认证 装饰器
 *
 */
export const Auth = () => {
  return (...args: any[]) => {
    // 装饰器由上至下求值，由下至上执行
    const decorators: any[] = [];
    decorators.push(UseGuards(AuthGuard));
    decorators.push(ApiBearerAuth());

    decorators.reverse().forEach((f) => f(...args));
  };
};
